import sys
import re

# 2023-09-18笔试后添加，不使用re模块来实现.和*的正则匹配
def is_match(s, p):
    m, n = len(s), len(p)
    
    # 创建一个二维数组来保存匹配结果，默认为 False
    dp = [[False] * (n + 1) for _ in range(m + 1)]
    
    # 空字符串与空模式匹配
    dp[0][0] = True
    
    # 处理模式中的 * 号
    for j in range(1, n + 1):
        if p[j - 1] == '*':
            dp[0][j] = dp[0][j - 2]
    
    # 填充动态规划表
    for i in range(1, m + 1):
        for j in range(1, n + 1):
            if p[j - 1] == s[i - 1] or p[j - 1] == '.':
                dp[i][j] = dp[i - 1][j - 1]
            elif p[j - 1] == '*':
                dp[i][j] = dp[i][j - 2] or (dp[i - 1][j] and (s[i - 1] == p[j - 2] or p[j - 2] == '.'))
    
    return dp[m][n]



if __name__ == "__main__":
    inputs = []
    for line in sys.stdin:
        inputs.append(line)

    if re.match(inputs[1], inputs[0]):
        print('1')
    else:
        print('0')